diff --git a/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19135.java b/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19135.java
new file mode 100644
index 000000000..9ded2b877
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/save/mcregion/SaveFormat19135.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.world.save.mcregion;
+
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.save.SaveFormatBase;
+
+import java.io.File;
+
+public class SaveFormat19135 extends SaveFormatBase {
+    public SaveFormat19135(File savesDir) {
+        super(savesDir);
+    }
+
+    @Override
+    public String getFormatName() {
+        return "BTARegion";
+    }
+
+    @Override
+    public int getSaveVersion() {
+        return 19135;
+    }
+
+    @Override
+    public void flushCache() {
+        RegionFileCache.flushCache();
+    }
+
+    @Override
+    public File getDimensionRootDir(String worldDirName, Dimension dimension) {
+        File worldDir = new File(savesDir, worldDirName);
+
+        File worldDimsDir = new File(worldDir, "dimensions");
+
+        return new File(worldDimsDir, Integer.toString(dimension.id));
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index 2acd63740..b28652865 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.config.season.SeasonConfig;
@@ -14,8 +15,6 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.season.Seasons;
-import net.minecraft.core.world.settings.WorldSettingNodes;
-import net.minecraft.core.world.settings.impl.WorldHeightSettingNode;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import net.minecraft.core.world.wind.WindProvider;
@@ -108,7 +107,7 @@ public abstract class WorldType
         return seasonConfig;
     }
 
-    public int getMinY(final @NotNull World world) {
+    public int getMinY(final @NotNull WorldSource world) {
 //        return world.getWorldSetting(WorldSettingNodes.WORLD_HEIGHT_BOTTOM) * WorldHeightSettingNode.VALUE_SCALE;
         return this.minY;
     }
@@ -117,7 +116,7 @@ public abstract class WorldType
         return minPortalY;
     }
 
-    public int getMaxY(final @NotNull World world) {
+    public int getMaxY(final @NotNull WorldSource world) {
 //        return (world.getWorldSetting(WorldSettingNodes.WORLD_HEIGHT_TOP) * WorldHeightSettingNode.VALUE_SCALE) - 1;
         return this.maxY;
     }
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/messages.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/messages.lang
new file mode 100644
index 000000000..094b367ce
--- /dev/null
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/messages.lang
@@ -0,0 +1,62 @@
+messages.player_joined=%s joined the game.
+messages.player_left=%s left the game.
+messages.player_kicked=%s left the game.
+
+messages.illegal_characters=[SERVER] Illegal characters in chat message.
+
+messages.sleep.succeed=%s went to sleep. Sweet dreams!
+messages.sleep.enter_bed=%s went to bed.
+messages.sleep.exit_bed=%s has left their bed.
+messages.sleep.more_required=%s more players are required to sleep to skip to daytime.
+messages.sleep.more_required.singular=%s more player is required to sleep to skip to daytime.
+
+messages.bed.occupied=This bed is occupied.
+messages.bed.noSleep=You can only sleep at night or during thunderstorms.
+messages.bed.setSpawn=Respawn point set.
+messages.bed.notValid=Your home bed was missing or obstructed.
+messages.bed.noAllowSleeping=Sleeping is disabled.
+messages.bed.unsafeToSleep=It's not safe to sleep here.
+
+messages.wand.wrongmode=You must be in Creative mode to use this item!
+
+messages.flag.full=You have too many flags on this map!
+messages.flag.overwrite=Cannot overwrite an existing pattern.
+messages.flag.copied=Flag pattern copied.
+
+messages.death.mob.generic=%s died.
+messages.death.mob.lava=%s swam in lava.
+messages.death.mob.spikes=%s got impaled.
+messages.death.mob.fall=%s broke their legs.
+messages.death.mob.drowned=%s suffocated.
+messages.death.mob.fire=%s was incinerated.
+messages.death.mob.killed_by=%s was killed by %s.
+
+messages.death.player.generic=%s died mysteriously.
+messages.death.player.lava=%s got lost in the sauce.
+messages.death.player.spikes=%s fell for the trap.
+messages.death.player.fall=%s forgot to tie their laces.
+messages.death.player.drowned=%s is sleeping with the fishes.
+messages.death.player.fire=%s was cooked well done.
+messages.death.player.tnt=%s was killed by Popbob.
+messages.death.player.lightning=%s was grounded.
+messages.death.player.herobrine=%s was killed by Herobrine.
+messages.death.player.killed_by=%s was backstabbed by %s.
+messages.death.player.killed_by.zombie=%s became a zombie.
+messages.death.player.killed_by.zombie_pig=%s discovered mob mentality.
+messages.death.player.killed_by.creeper=%s didn't see the creeper.
+messages.death.player.killed_by.skeleton=%s was a victim of aimbot.
+messages.death.player.killed_by.spider=%s spent too much time on the web.
+messages.death.player.killed_by.ghast=%s didn't return the serve.
+messages.death.player.killed_by.slime=%s was slimed.
+messages.death.player.killed_by.wolf=%s got what they deserved.
+messages.death.player.killed_by.giant=%s was killed by- wait, what?!
+messages.death.player.killed_by.pig=%s is *really* bad at Minecraft.
+messages.death.player.killed_by.arrow=%s is a pincushion.
+messages.death.player.killed_by.arrow_player=%s got 360 noscoped by %s.
+messages.death.player.killed_by.arrow_suicide=%s lost a game of Russian roulette.
+messages.death.player.killed_by.arrow_golden=%s is Swiss cheese.
+messages.death.player.killed_by.arrow_golden_player=%s got pierced by %s.
+messages.death.player.killed_by.arrow_golden_suicide=%s got gold in their eye.
+messages.death.player.killed_by.cannonball=%s was detonated remotely.
+messages.death.player.killed_by.cannonball_player=%s was fragmented by %s.
+messages.death.player.killed_by.cannonball_suicide=%s jumped too high.
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/strings.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/strings.lang
index a9e8760e3..24a86e707 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/strings.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/strings.lang
@@ -88,13 +88,6 @@ damagetype.fire=Fire
 
 progress.tip=Tip: %s
 
-bed.occupied=This bed is occupied.
-bed.noSleep=You can only sleep at night or during thunderstorms.
-bed.setSpawn=Respawn point set.
-bed.notValid=Your home bed was missing or obstructed.
-bed.noAllowSleeping=Sleeping is disabled.
-bed.unsafeToSleep=It's not safe to sleep here.
-
 sign.image.none=None
 sign.image.arrow_right=Right Arrow
 sign.image.arrow_left=Left Arrow
@@ -154,12 +147,6 @@ record.ward=Ward
 record.wait=Wait
 record.dog=Dog
 
-flag.full=You have too many flags on this map!
-flag.overwrite=Cannot overwrite an existing pattern.
-flag.copied=Flag pattern copied.
-
-wand.wrongmode=You must be in Creative mode to use this item!
-
 save.data.missing.data=Level Metadata Missing!
 
 unit.day=Day
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 5e4f98e5d..54b837927 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -31,6 +31,7 @@ import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.save.mcregion.SaveFormat19135;
 import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.core.world.type.WorldTypeGroups;
 import net.minecraft.server.entity.player.PlayerServer;
@@ -377,7 +378,7 @@ public class MinecraftServer
             }
         }
         LOGGER.info("Preparing level \"{}\"", lName);
-        initWorld(new SaveFormat19134(new File(".")), lName, randomLong);
+        initWorld(new SaveFormat19135(new File(".")), lName, randomLong);
         LOGGER.info("Generating RSA key...");
         try
         {
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index e19d0734f..b9979de3a 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -716,13 +716,6 @@ public class PlayerServer extends Player implements ContainerListener {
         lastHealth = Integer.MIN_VALUE;
         lastScore = Integer.MIN_VALUE;
     }
-
-    public void func_22061_a(String s)
-    {
-        I18n stringtranslate = I18n.getInstance();
-        String s1 = stringtranslate.translateKey(s);
-        playerNetServerHandler.sendPacket(new PacketChat(s1));
-    }
     
     @Override
     public void setCurrentItem(int i) {
@@ -750,14 +743,24 @@ public class PlayerServer extends Player implements ContainerListener {
     }
 
     @Override
-	public void sendMessage(String message) {
-		playerNetServerHandler.sendPacket(new PacketChat(message, 0, AES.keyChain.get(username)));
-	}
+    public void sendMessage(boolean isStatus, @Nullable TextFormatting.Base format, @NotNull String message) {
+        playerNetServerHandler.sendPacket(new PacketMessage(
+            format, message,
+            (isStatus) ? PacketMessage.TYPE_STATUS : PacketMessage.TYPE_CHAT,
+            AES.keyChain.get(username)
+        ));
+    }
 
-	@Override
-	public void sendStatusMessage(String message) {
-		playerNetServerHandler.sendPacket(new PacketChat(message, 1, AES.keyChain.get(username)));
-	}
+    @Override
+    public void sendMessageTranslated(boolean isStatus, @Nullable TextFormatting.Base format, @NotNull String key, @NotNull String... args) {
+        final var id = PacketMessageTranslatable.KEY2ID_MAP.getOrDefault(key, (short)-1);
+        if (id == -1) return;
+        playerNetServerHandler.sendPacket(new PacketMessageTranslatable(
+            format, id,
+            (isStatus) ? PacketMessageTranslatable.TYPE_STATUS : PacketMessageTranslatable.TYPE_CHAT,
+            args
+        ));
+    }
 
     public void teleport(double x, double y, double z, float yaw, float pitch) {
         playerNetServerHandler.teleportAndRotate(x, y, z, yaw, pitch);
diff --git a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
index 8f4308871..8719b4eab 100644
--- a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -235,7 +235,7 @@ public class PlayerList
             }
             else
             {
-                newPlayer.playerNetServerHandler.sendPacket(new PacketBedMessage(0));
+                newPlayer.playerNetServerHandler.sendPacket(new PacketMessageTranslatable("messages.bed.notValid"));
             }
         }
         worldserver.getChunkProvider().prepareChunk((int) newPlayer.x >> 4, (int) newPlayer.z >> 4);
@@ -336,7 +336,7 @@ public class PlayerList
     public void sendEncryptedChatToAllPlayers(String message)
     {
         for (PlayerServer player : playerEntities) {
-            player.playerNetServerHandler.sendPacket(new PacketChat(message, 0, AES.keyChain.get(player.username)));
+            player.playerNetServerHandler.sendPacket(new PacketMessage(message, PacketMessage.TYPE_CHAT, AES.keyChain.get(player.username)));
         }
 
     }
@@ -603,7 +603,7 @@ public class PlayerList
         PlayerServer player = getPlayerEntity(s);
         if (player != null)
         {
-            player.playerNetServerHandler.sendPacket(new PacketChat(s1));
+            player.playerNetServerHandler.sendPacket(new PacketMessage(s1));
         }
     }
 
@@ -631,7 +631,7 @@ public class PlayerList
 
     public void sendChatMessageToAllOps(String s)
     {
-        PacketChat chatPacket = new PacketChat(s);
+        PacketMessage chatPacket = new PacketMessage(s);
         for (PlayerServer player : playerEntities) {
             if (isOp(player.uuid)) {
                 player.playerNetServerHandler.sendPacket(chatPacket);
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
index 018cb51b8..930940cd7 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
@@ -3,7 +3,7 @@ package net.minecraft.server.net.command;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandSource;
-import net.minecraft.core.net.packet.PacketChat;
+import net.minecraft.core.net.packet.PacketMessage;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.LoggedPrintStream;
@@ -89,12 +89,12 @@ public class ConsoleCommandSource implements CommandSource, IServerCommandSource
 
     @Override
     public void sendMessage(Player player, String message) {
-        this.server.playerList.sendPacketToPlayer(player.username, new PacketChat(message, AES.keyChain.get(player.username)));
+        this.server.playerList.sendPacketToPlayer(player.username, new PacketMessage(message, AES.keyChain.get(player.username)));
     }
 
     @Override
     public void sendMessageToAllPlayers(String message) {
-        this.getServer().playerList.sendPacketToAllPlayers(new PacketChat(message));
+        this.getServer().playerList.sendPacketToAllPlayers(new PacketMessage(message));
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
index d22bdf7ce..9475420f2 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -2,7 +2,7 @@ package net.minecraft.server.net.command;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandSource;
-import net.minecraft.core.net.packet.PacketChat;
+import net.minecraft.core.net.packet.PacketMessage;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.world.World;
@@ -88,17 +88,17 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
 
     @Override
     public void sendMessage(String message) {
-        this.player.playerNetServerHandler.sendPacket(new PacketChat(message, AES.keyChain.get(this.player.username)));
+        this.player.playerNetServerHandler.sendPacket(new PacketMessage(message, AES.keyChain.get(this.player.username)));
     }
 
     @Override
     public void sendMessage(Player player, String message) {
-        this.server.playerList.sendPacketToPlayer(player.username, new PacketChat(message, AES.keyChain.get(player.username)));
+        this.server.playerList.sendPacketToPlayer(player.username, new PacketMessage(message, AES.keyChain.get(player.username)));
     }
 
     @Override
     public void sendMessageToAllPlayers(String message) {
-        this.getServer().playerList.sendPacketToAllPlayers(new PacketChat(message));
+        this.getServer().playerList.sendPacketToAllPlayers(new PacketMessage(message));
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandMe.java b/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandMe.java
index fab171f39..ce26b6764 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandMe.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandMe.java
@@ -12,7 +12,7 @@ import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.server.net.command.IServerCommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
-import net.minecraft.core.net.packet.PacketChat;
+import net.minecraft.core.net.packet.PacketMessage;
 
 public class CommandMe implements CommandManager.CommandRegistry {
     public void register(CommandDispatcher<CommandSource> dispatcher) {
@@ -28,7 +28,7 @@ public class CommandMe implements CommandManager.CommandRegistry {
                         String senderName = source.getSender().getDisplayName();
 
                         ((IServerCommandSource) source).getServer().playerList.sendPacketToAllPlayers(
-                            new PacketChat(
+                            new PacketMessage(
                             TextFormatting.LIGHT_GRAY + "* " + (source.getSender().nickname.isEmpty() ? "" : TextFormatting.ITALIC) + TextFormatting.removeAllFormatting(senderName) + " " + TextFormatting.RESET + TextFormatting.LIGHT_GRAY + message
                             )
                         );
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
index 6eb917c79..71ce7fd58 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
@@ -213,12 +213,17 @@ public class PacketHandlerLogin extends PacketHandler
 
             packetHandler.sendPacket(new PacketSetSpawnPosition(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z));
             mcServer.playerList.setTime(player, worldserver);
-            mcServer.playerList.sendPacketToAllPlayers(new PacketChat(TextFormatting.YELLOW + player.getDisplayName() + TextFormatting.YELLOW + " joined the game."));
+            mcServer.playerList.sendPacketToAllPlayers(new PacketMessageTranslatable(
+                TextFormatting.Base.YELLOW,
+                "messages.player_joined",
+                TextFormatting.scoped(player.getDisplayName())
+
+            ));
             mcServer.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
 
             if (mcServer.joinMessage != null && !mcServer.joinMessage.isEmpty())
             {
-                player.playerNetServerHandler.sendPacket(new PacketChat(mcServer.joinMessage));
+                player.playerNetServerHandler.sendPacket(new PacketMessage(mcServer.joinMessage));
             }
 
             mcServer.playerList.playerLoggedIn(player);
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index f537cb748..c4b7aeb1a 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -91,7 +91,11 @@ public class PacketHandlerServer extends PacketHandler
         this.playerEntity.func_30002_A();
         sendPacket(new PacketDisconnect(s));
         this.netManager.serverShutdown();
-        this.mcServer.playerList.sendPacketToAllPlayers(new PacketChat(this.playerEntity.getDisplayName() + TextFormatting.YELLOW + " was kicked from the game."));
+        this.mcServer.playerList.sendPacketToAllPlayers(new PacketMessageTranslatable(
+            TextFormatting.Base.YELLOW,
+            "messages.player_kicked",
+            TextFormatting.scoped(this.playerEntity.getDisplayName())
+        ));
         this.mcServer.playerList.updatePlayerProfile(this.playerEntity.username, this.playerEntity.nickname, this.playerEntity.uuid, this.playerEntity.score, this.playerEntity.chatColor, false, this.playerEntity.isOperator());
         this.mcServer.playerList.playerLoggedOut(this.playerEntity);
         this.connectionClosed = true;
@@ -447,7 +451,11 @@ public class PacketHandlerServer extends PacketHandler
     @Override
     public void handleErrorMessage(String message, Object[] objects) {
         LOGGER.info(this.playerEntity.username + " lost connection: " + message);
-        this.mcServer.playerList.sendPacketToAllPlayers(new PacketChat(this.playerEntity.getDisplayName() + TextFormatting.YELLOW + " left the game."));
+        this.mcServer.playerList.sendPacketToAllPlayers(new PacketMessageTranslatable(
+            TextFormatting.Base.YELLOW,
+            "messages.player_left",
+            TextFormatting.scoped(this.playerEntity.getDisplayName())
+        ));
         this.mcServer.playerList.updatePlayerProfile(this.playerEntity.username, this.playerEntity.nickname, this.playerEntity.uuid, this.playerEntity.score, this.playerEntity.chatColor, false, this.playerEntity.isOperator());
         this.mcServer.playerList.playerLoggedOut(this.playerEntity);
         this.connectionClosed = true;
@@ -481,13 +489,13 @@ public class PacketHandlerServer extends PacketHandler
     }
 
     @Override
-    public void handleChat(@NotNull PacketChat packet) {
+    public void handleMessage(@NotNull PacketMessage packet) {
         String message;
         if (packet.encrypted) {
             try {
                 message = AES.decrypt(packet.message, AES.keyChain.get(this.playerEntity.username));
             } catch (Exception e) {
-                throw new RuntimeException(PacketChat.ENCRYPTION_ERROR_MESSAGE, e);
+                throw new RuntimeException(PacketMessage.ENCRYPTION_ERROR_MESSAGE, e);
             }
         } else {
             message = packet.message;
@@ -500,7 +508,10 @@ public class PacketHandlerServer extends PacketHandler
         message = message.trim();
 
         if (!NetCharacters.isAllowed(message)) {
-            sendPacket(new PacketChat(String.valueOf(TextFormatting.GRAY) + TextFormatting.ITALIC + "[SERVER] Illegal characters in chat message."));
+            this.sendPacket(new PacketMessageTranslatable(
+                TextFormatting.Base.GRAY.withStyle(false, false, false, false, true, false),
+                "messages.illegal_characters"
+            ));
             return;
         }
 
@@ -519,7 +530,7 @@ public class PacketHandlerServer extends PacketHandler
         try {
             this.playerEntity.world.getCommandManager().execute(s.substring(1), serverCommandSource);
         } catch (CommandSyntaxException e) {
-            this.playerEntity.playerNetServerHandler.sendPacket(new PacketChat(TextFormatting.RED + e.getMessage(), AES.keyChain.get(this.playerEntity.username)));
+            this.playerEntity.playerNetServerHandler.sendPacket(new PacketMessage(TextFormatting.RED + e.getMessage(), AES.keyChain.get(this.playerEntity.username)));
         }
     }
 
@@ -569,7 +580,7 @@ public class PacketHandlerServer extends PacketHandler
 
     @Override
     public void logInfo(String s) {
-        sendPacket(new PacketChat("\2477" + s));
+        sendPacket(new PacketMessage("\2477" + s));
     }
 
     @Override
@@ -738,9 +749,9 @@ public class PacketHandlerServer extends PacketHandler
     public void handleCustomPayload(@NotNull PacketCustomPayload packetCustomPayload) {
         if (PacketCustomPayload.CHANNEL_ROTATION_LOCK.equals(packetCustomPayload.channel)) {
             if (packetCustomPayload.data.length == 4) {
-                this.playerEntity.rotationLock = Direction.fromId(packetCustomPayload.data[0]);
-                this.playerEntity.rotationLockHorizontal = Direction.fromId(packetCustomPayload.data[1]);
-                this.playerEntity.rotationLockVertical = Direction.fromId(packetCustomPayload.data[2]);
+                this.playerEntity.rotationLock = Direction.fromIdOrDefault(null, packetCustomPayload.data[0]);
+                this.playerEntity.rotationLockHorizontal = Direction.fromIdOrDefault(null, packetCustomPayload.data[1]);
+                this.playerEntity.rotationLockVertical = Direction.fromIdOrDefault(null, packetCustomPayload.data[2]);
                 this.playerEntity.placementModeOverride = PlacementMode.get(packetCustomPayload.data[3]);
             }
         } else if (PacketCustomPayload.CHANNEL_FLAG.equals(packetCustomPayload.channel)) {
